<?php
  session_start();

/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/

  // Script to change the password.
  // Chris Pinchak, May 17, 2001
  // Chris 20010522: Changed the position of the password change so that
  // database access is done before html headers are sent.
  session_register('username');
  session_register('sessionkey'); 

  include ("dbutils.php");
  include("PBSWebConstants.php");
  DB_authPage($sessionkey);

  // compare the new passwords.
  if ($newpasswd != $newpasswd2)
    $result_string = "New passwords did not match.  No changes were made.";
  // verify the new passwords.
  else if (db_check_passwd($username, $oldpasswd) == PBSFALSERET)
    $result_string = "Unable to verify your old password.  This could be " .
      "because you typed it incorrectly, or a problem with the database." . 
      "  No changes were made<br>";
  else
    // make the change.
    if (db_change_passwd($username, $oldpasswd, $newpasswd) == PBSFALSERET)
      $result_string = "Database failed on password modification.  Assume " .
      "that no changes were made<br>";
    else
      $result_string = "Password was changed successfully<br>";
  
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>Password Changed</title>
  </head>
  <body bgcolor="white">
    <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">Results of Password Change
    </h1>
    <hr>
    <?php
      print($result_string);
    ?>
    <hr>
    <table>
      <tr>
        <td><a href="mainmenu.php">Start Page</a></td>
      </tr>
      <tr>
        <td>Send questions and comments to <a
          href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a>.
          You can find <a href='help.html'> help here </a>.</td>
      </tr>  
    </table>
  </body>
</html>
