<?php
  session_start();
/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/

  // Chris Pinchak, May 16, 2001
  session_register('username');
  session_register('sessionkey');

  include ("dbutils.php");
  include("PBSWebConstants.php");

  DB_authPage($sessionkey);

  $local_debug = 0;

  if (!$host)
      $host = $DEFAULTHOST;
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <title>PBSWeb Job Output</title>
  </head>
  <body bgcolor="white">
  <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">PBSWeb Job Output
  </h1>
<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>

  <hr>
	<font color=blue>This may take tens of seconds!  A faster implementation is under development.</font>

<!--
	<p><font color=red>NOTE:  Warning messages about "Wrong datatype in arsort()" (and other warnings) under some circumstances is a known problem.  It should not affect the viewing of valid output files.</font>
-->

  <form method="POST" action="programselecto.php">
    <table>
      <tr>
        <th>Host:</th>
        <td>
	  <select name="host" onChange="window.document.forms[0].submit()">
	    <?php
	      //get the list of hosts from the database
	      $hostlist = DB_get_machines_list($username);
	      $hostcount = sizeof($hostlist);
	      for($i = 0; $i < $hostcount; $i++) {
	          $curhost = $hostlist[$i];
	          if ($curhost==$host)
		    echo "<OPTION VALUE=\x22$curhost\x22 SELECTED>$curhost";
		  else
		    echo "<OPTION VALUE=\x22$curhost\x22>$curhost";
	      }
	    ?>
	  </select>
        </td>
        <!-- <td><INPUT TYPE="submit" VALUE="Reload"></td> -->
      </tr>
    </table>
  </form>

<?php


# Paul
# Alberta-specific:  $SSH_CMD = "~pbsweb/Bin/ssh_via_proxy ";
$SSH_CMD = "ssh ";

// get the remote directory listing.
$rcmd = "'cd $PBSWEBDIR; ls -F | grep /; exit'";
$rawremote_ls = `$SSH_CMD $username@$host $rcmd 2>&1`;

// explode the string into individual names.
$rawremote_ls = str_replace( "/", "", $rawremote_ls );  // Clean up a bit first
    if( $local_debug == 1 )
    {
	print "<br>Remote ls:  <b>"; print $rawremote_ls; print "</b><br>";
    }
$rawremote_ls = explode("\n", $rawremote_ls);


// scp over the script that prints the file modification time as a UNIX
// timestamp.
$junk = `scp fmodtime.py "$username@$host:$PBSWEBDIR/fmodtime.py" 2>&1`;

// Simply create an array, used with array_push() later
$file_list = array();
$remote_ls = array();

// Paul removed the -1
# for ($i = 0; $i < sizeof($rawremote_ls) - 1; $i++) {
for ($i = 0; $i < sizeof($rawremote_ls); $i++) {
	
	// get the files in each directory, using grep on the remote machine to
	// select only those matching a certain pattern.
	//	$file_list[$i] = 
	$ls_output =
		 `$SSH_CMD $username@$host "cd $PBSWEBDIR/$rawremote_ls[$i]; ls | grep '\.o[0-9][0-9]*'; exit" 2>&1`;

	// Skip the directories that have no output files
	if( strlen( $ls_output ) > 0 )
	{
		$ls_output = explode("\n", $ls_output);
		array_push( $file_list, $ls_output );
		array_push( $remote_ls, $rawremote_ls[$i] );
	} // if
} // for

    if( $local_debug == 1 )
    {
	print "<br><b>After filter: "; print implode( " ", $remote_ls ); print "</b><br>";
    }


// Paul removed the -1
# for ($i = 0; $i < sizeof($file_list) - 1; $i++) {
for ($i = 0; $i < sizeof($file_list) ; $i++) {

    if( $local_debug == 1 )
    {
	print "<br>"; print $remote_ls[$i]; print "-->";
	print implode( " ", $file_list[$i] ); print "<br>";
    }

	for ($j = 0; $j < sizeof($file_list[$i]) - 1; $j++) {
		$this_file = $file_list[$i][$j];
		
// FIXME:  Make this faster, use xargs
		// run the script on each file to get it's modification time.
		$time_array[$i][$j] = `$SSH_CMD $username@$host "cd $PBSWEBDIR/$remote_ls[$i]; python ../fmodtime.py ./$this_file; exit" 2>&1`;
	}
}

// we no longer need the script, so delete it.  The script is < 1KB.
$junk = `$SSH_CMD $username@$host 'cd $PBSWEBDIR; rm -f fmodtime.py 2>/dev/null; exit' 2>&1`;

for ($i = 0; $i < sizeof($file_list); $i++)
	 for ($j = 0; $j < sizeof($file_list[$i]) - 1; $j++) {
		 $filename = $file_list[$i][$j];
		 
		 // The hash table has a numerical first index, followed by
		 // the filename as the second index.  The values stored are
		 // the timestamps.  The numerical first value corresponds to
		 // a directory name in $remote_ls.
		 $hash_table[$i][$filename] = $time_array[$i][$j];
	 }
for ($i = 0; $i < sizeof($hash_table); $i++)
{
	 // Sort each directory of files in place in reverse order according to the
	 // timestamp.
	 arsort($hash_table[$i]);
}
	 
for ($i = 0; $i < sizeof($hash_table); $i++) {
    reset($hash_table[$i]);

    // The max_time array holds the maximum timestamp for a file in that array.
    // The maximum value should be the first timestamp for that directory in
    // the hash table.
    $max_time[$i] = current($hash_table[$i]);
    if (!$max_time[$i])
	    $max_time[$i] = -1;
    reset($hash_table[$i]);
}

// Reverse sort the list of maximum timestamps.
arsort($max_time);

reset($max_time);

// Now start printing out the directories and their associated files, in
// decreasing timestamp order.

$current_dir = key($max_time);
if ($remote_ls[$current_dir]) {
    print("<h1>" . $remote_ls[$current_dir] . "</h1><table width=\"50%\">");
    $current_file = key($hash_table[$current_dir]);
    if ($current_file)
	    print("<tr><td><a href=\"fileview.php?host=$host&dir=$remote_ls[$current_dir]&file=$current_file\">$current_file</a></td>
             <td>" . date("d/m/Y g:i:sa", current($hash_table[$current_dir])) .
		     "</td></tr>");
    $num_lines = 1;

    // We only want the first 10 entries in each directory.  Some people
    // might have a lot of output files.

    while (next($hash_table[$current_dir]) && $num_lines < 10) {
        $current_file = key($hash_table[$current_dir]);

        // Have a link to view the contents of the file.  Also print the file
        // modification time/date.
        print("<tr><td><a href=\"fileview.php?host=$host&dir=$remote_ls[$current_dir]&file=$current_file\">$current_file</td>
             <td>" . date("d/m/Y g:i:sa", current($hash_table[$current_dir])) .
		     "</td></tr>");

        $num_lines = $num_lines + 1;
    }
    print("</table>");
}

// Repeat the above.  Next is a strange little function in PHP.  It never
// gives you the first element!
while (next($max_time)) {
    $current_dir = key($max_time);
    print("<h1>" . $remote_ls[$current_dir] . "</h1><table width=\"50%\">");
    $current_file = key($hash_table[$current_dir]);
    if ($current_file)
	    print("<tr><td><a href=\"fileview.php?host=$host&dir=$remote_ls[$current_dir]&file=$current_file\">$current_file</a></td>
            <td>" . date("d/m/Y g:i:sa", current($hash_table[$current_dir])) .
	        "</td></tr>");
    $num_lines = 1;
    while (next($hash_table[$current_dir]) && $num_lines < 10) {
        $current_file = key($hash_table[$current_dir]);
        print("<tr><td><a href=\"fileview.php?host=$host&dir=$remote_ls[$current_dir]&file=$current_file\">$current_file</a></td>
            <td>" . date("d/m/Y g:i:sa", current($hash_table[$current_dir])) . 
            "</td></tr>");
        $num_lines = $num_lines + 1;
    }
    print("</table>");
}
?>
  <hr>

<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>

  <table border="0">
    <tr>
    <td>Suggested Next Step: <a href="mainmenu.php">Start Page</a></td>
    </tr>
    <tr>
    <td>Send questions and comments to <a
    href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a>. You can find
    <a href='help.html'> help here </a>.</td>
    </tr>
    </table>
  </body>
</html>
