<?php
  session_cache_limiter('private');
  session_start();
/*

PBSWeb: A Web-based Interface to PBS
Copyright (C) 2000, 2001  Paul Lu

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

.......................
Please leave this copyright notice intact.
See http://www.gnu.org/copyleft/gpl.html for further details

Contact information:
	Paul Lu
	Assistant Professor
	Dept. of Computing Science
	Athabasca Hall
	University of Alberta
	Edmonton, Alberta, T6G 2E8
	Canada

	E-mail:         paullu@cs.ualberta.ca
	Web:            http://www.cs.ualberta.ca/~paullu/

Other contributors to PBSWeb (as of July 2001)
	George Ma, Victor Salamon, Christopher Pinchak, Yaling Pei,
	Jonathan Schaeffer, Duane Szafron
*/

  session_register('username');
  session_register('sessionkey'); 

  include("dbutils.php");
  include("PBSWebConstants.php");
  
  DB_authPage($sessionkey); 

  if (!$host) {
    $host = $DEFAULTHOST;
}

  $qstat_cmd = DB_getHostInfo($host, "qstat");
  if ($qstat_cmd == PBSFALSERET) {
    dispErrorPageAutoHelp("Failed retrieving qstat command");
    die();
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
	<META HTTP-EQUIV="no-cache">
	<META HTTP-EQUIV="Pragma" CONTENT="no-cache"> 
    <title>PBSWeb Queue Status</title>
 <script language="JavaScript"><!--
	setTimeout("window.document.forms[0].submit()",60000);
//-->
      </script>
  </head>
  <body bgcolor="white">
    <h1>
    <img src="img/littlepbsguy.jpg" border="0" height="102" width="92" alt="PBS Logo">PBSWeb Queue Status
    </h1>

<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>

    <hr>
<form method="POST" action="qstat.php">
<table><tr><th>Host:</th><td><select name="host" onChange="window.document.forms[0].submit()">
<?php 
           #get the list of hosts from the database
	   $hostlist = DB_get_machines_list($username);
	   $hostcount = sizeof($hostlist);
	   for($i=0;$i<$hostcount;$i++) {
	     $curhost=$hostlist[$i];
	     if ($curhost==$host) {
	       echo "<OPTION VALUE=\x22$curhost\x22 SELECTED>$curhost";
	     }
	     else {
	       echo "<OPTION VALUE=\x22$curhost\x22>$curhost";
	     }
	   }
	?>
    </select></td><td><INPUT TYPE="submit" VALUE="Reload"></td></tr></table>
</form>
    <?php
    $qstat = `ssh -l $username $host '$qstat_cmd; exit' 2>&1`;
    $qstatB = `ssh -l $username $host '$qstat_cmd -B; exit' 2>&1`;
    $qstatQ = `ssh -l $username $host '$qstat_cmd -Q; exit' 2>&1`;
    ?>
    <h2>Current Job Queue</h2>
    <!-- 20010510 Chris added links to job id and for deletion. -->
    <table width=90% align="center" border=0>
    <?php 
    $stringarray = explode("\n", $qstat);
    for ($i = 0; $i < sizeof($stringarray) - 1; $i = $i + 1) {
	print("<tr>");
	if ($i == 0) {
		$stringarray[$i] = str_replace("Job id", "Job-id",
			$stringarray[$i]);
		$stringarray[$i] = str_replace("Time Use", "Time-Use",
			$stringarray[$i]);
	}
	$the_new_line = ereg_replace('(  *)', " ", $stringarray[$i]);
	$line_array = explode(" ", $the_new_line);
	$jobid = (int) $line_array[0];
	for ($j = 0; $j < sizeof($line_array); $j = $j + 1) {
		print('<td align="center">');
		if ($j == 0 && $i > 1)
			print("<a href=\"jobstatus.php?id=$jobid&host=$host\">
				$line_array[$j]</a></td>");
		else
			print("$line_array[$j]</td>");
	}
	if ($username == $line_array[2])
		print("<td><a href=\"confirm.php?id=$jobid&host=$host\">
		    Delete</a></td>");
	print("</tr>");
    }
    ?>
    </table>

    <h2>Queue Configuration</h2>
    <pre><?php echo $qstatQ; ?></pre>
    <h2>Server Status</h2>
    <pre><?php echo $qstatB; ?></pre>

<?php
  /* Put standard navigation menu */
  include("navbar.php");
?>

    <hr>
    <table border="0">
    <tr>
    <td>Send questions and comments to <a
    href="mailto:pbsweb@cs.ualberta.ca">pbsweb@cs.ualberta.ca</a>. You can find <a
    href='help.html'> help here </a>.</td>
    </tr>  
    </table>
  </body>
</html>
  
